
Ruby - Bug #11179

Inconsistent Addrinfo parsing a port number

05/25/2015 07:01 AM - ibenza (Shin'ya Ueoka)

Status: Third Party's Issue   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.0dev (2015-05-25 trunk 50637)

[x86_64-linux] 

Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:

UNKNOWN

Description

In the case of the following code, ip_port returns 34464 because the number 99999 is cast as short int.

Is the result expected?

require 'socket'

Addrinfo.tcp('', 99999).ip_port    # => 34463

 Even if the above behavior is correct, ip_port should return 65535 in the following code.  But actually, Addrinfo raises an exception

because -1 is parsed as service name.  This behavior is inconsistent with the above.

require 'socket'

Addrinfo.tcp('', -1).ip_port     # => Servname not supported for ai_socktype (SocketError)

Associated revisions

Revision 2f8d3280e0bbbf6d964d84ab4ae9456a1e8e8eb0 - 06/14/2015 10:11 AM - akr (Akira Tanaka)

ext/socket/raddrinfo.c (parse_numeric_port): Detect

port overflow.

(numeric_getaddrinfo): Use parse_numeric_port.

numeric_getaddrinfo fails if port is too big now.

This makes rb_getaddrinfo invokes the real getaddrinfo()

on such condition.

This change is related to [ruby-core:69355] [Bug #11179].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50890 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2f8d3280 - 06/14/2015 10:11 AM - akr (Akira Tanaka)

ext/socket/raddrinfo.c (parse_numeric_port): Detect

port overflow.

(numeric_getaddrinfo): Use parse_numeric_port.

numeric_getaddrinfo fails if port is too big now.

This makes rb_getaddrinfo invokes the real getaddrinfo()

on such condition.

This change is related to [ruby-core:69355] [Bug #11179].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@50890 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/25/2015 08:50 AM - ibenza (Shin'ya Ueoka)

- Subject changed from Addrinfo parsing a port number to Inconsistent Addrinfo parsing a port number

#2 - 06/14/2015 09:39 AM - akr (Akira Tanaka)

- Status changed from Open to Third Party's Issue

The behavior is inherited from getaddrinfo() function in libc.

So it is difficult to fix the problem in Ruby.
